Attribute VB_Name = "VertexModule"
'Dieser Source stammt von http://www.vb-fun.de und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

Public vxWand() As D3DLVERTEX
Public vxBoden() As D3DLVERTEX
Public vxSky() As D3DLVERTEX
Public vxHorizont() As D3DLVERTEX

Const WandBreite As Single = 10
Const WandHoehe As Single = 13.4
Const BodenUrsprung As Single = 0
Const AnzahlWaende As Integer = 4
Const SkyHoehe As Single = 50

Public Sub SetVertex()
    On Error GoTo ErrOut
    ReDim vxWand((AnzahlWaende * 6) - 1)
    ReDim vxBoden(5)
    ReDim vxSky(5)
    ReDim vxHorizont(23)
    CreateWall 6, 5, 5, 5, 0
    CreateWall 6, 4, 6, 5, 6
    CreateWall 5, 4, 6, 4, 12
    CreateWall 5, 5, 5, 4, 18
    CreateBoden -50, 50, 50, 50, 50, -50, -50, -50, 0
    CreateSky 0
    CreateHorizont 0
    Exit Sub
ErrOut:
    Debug.Print Err.Number & " - " & Err.Description
End Sub

Public Sub CreateWall(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByVal StartVertex As Integer)
    Dim color As Long
    On Error GoTo ErrOut
    color = DX7.CreateColorRGBA(1#, 1#, 1#, 1#)
    DX7.CreateD3DLVertex (X1 * WandBreite), (BodenUrsprung + WandHoehe), (Y1 * WandBreite), color, color, 0, 0, vxWand(StartVertex)
    DX7.CreateD3DLVertex (X2 * WandBreite), (BodenUrsprung), (Y2 * WandBreite), color, color, 1, 1, vxWand(StartVertex + 1)
    DX7.CreateD3DLVertex (X1 * WandBreite), (BodenUrsprung), (Y1 * WandBreite), color, color, 0, 1, vxWand(StartVertex + 2)
    DX7.CreateD3DLVertex (X1 * WandBreite), (BodenUrsprung + WandHoehe), (Y1 * WandBreite), color, color, 0, 0, vxWand(StartVertex + 3)
    DX7.CreateD3DLVertex (X2 * WandBreite), (BodenUrsprung + WandHoehe), (Y2 * WandBreite), color, color, 1, 0, vxWand(StartVertex + 4)
    DX7.CreateD3DLVertex (X2 * WandBreite), (BodenUrsprung), (Y2 * WandBreite), color, color, 1, 1, vxWand(StartVertex + 5)
    Exit Sub
ErrOut:
    Debug.Print Err.Number & " - " & Err.Description
End Sub

Public Sub CreateBoden(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, _
                      ByVal X3 As Single, ByVal Y3 As Single, ByVal X4 As Single, ByVal Y4 As Single, _
                      ByVal StartVertex As Integer)
    Dim color As Long
    On Error GoTo ErrOut
    color = DX7.CreateColorRGBA(1#, 1#, 1#, 1#)
    DX7.CreateD3DLVertex (X1 * WandBreite), (BodenUrsprung), (Y1 * WandBreite), color, color, 0, 0, vxBoden(StartVertex)
    DX7.CreateD3DLVertex (X3 * WandBreite), (BodenUrsprung), (Y3 * WandBreite), color, color, 100, 100, vxBoden(StartVertex + 1)
    DX7.CreateD3DLVertex (X4 * WandBreite), (BodenUrsprung), (Y4 * WandBreite), color, color, 0, 100, vxBoden(StartVertex + 2)
    DX7.CreateD3DLVertex (X1 * WandBreite), (BodenUrsprung), (Y1 * WandBreite), color, color, 0, 0, vxBoden(StartVertex + 3)
    DX7.CreateD3DLVertex (X2 * WandBreite), (BodenUrsprung), (Y2 * WandBreite), color, color, 100, 0, vxBoden(StartVertex + 4)
    DX7.CreateD3DLVertex (X3 * WandBreite), (BodenUrsprung), (Y3 * WandBreite), color, color, 100, 100, vxBoden(StartVertex + 5)
    Exit Sub
ErrOut:
    Debug.Print Err.Number & " - " & Err.Description
End Sub

Public Sub CreateSky(ByVal StartVertex As Integer)
    Dim color As Long
    On Error GoTo ErrOut
    color = DX7.CreateColorRGBA(1#, 1#, 1#, 1#)
    DX7.CreateD3DLVertex -500, SkyHoehe, 500, color, color, 0, 0, vxSky(StartVertex)
    DX7.CreateD3DLVertex -500, SkyHoehe, -500, color, color, 0, 20, vxSky(StartVertex + 1)
    DX7.CreateD3DLVertex 500, SkyHoehe, -500, color, color, 20, 20, vxSky(StartVertex + 2)
    DX7.CreateD3DLVertex -500, SkyHoehe, 500, color, color, 0, 0, vxSky(StartVertex + 3)
    DX7.CreateD3DLVertex 500, SkyHoehe, -500, color, color, 20, 20, vxSky(StartVertex + 4)
    DX7.CreateD3DLVertex 500, SkyHoehe, 500, color, color, 20, 0, vxSky(StartVertex + 5)
    Exit Sub
ErrOut:
    Debug.Print Err.Number & " - " & Err.Description
End Sub

Public Sub CreateHorizont(ByVal StartVertex As Integer)
    Dim color As Long
    On Error GoTo ErrOut
    color = DX7.CreateColorRGBA(1#, 1#, 1#, 1#)
    DX7.CreateD3DLVertex -500, SkyHoehe, 500, color, color, 0, 0, vxHorizont(StartVertex)
    DX7.CreateD3DLVertex 500, BodenUrsprung, 500, color, color, 1, 1, vxHorizont(StartVertex + 1)
    DX7.CreateD3DLVertex -500, BodenUrsprung, 500, color, color, 0, 1, vxHorizont(StartVertex + 2)
    DX7.CreateD3DLVertex -500, SkyHoehe, 500, color, color, 0, 0, vxHorizont(StartVertex + 3)
    DX7.CreateD3DLVertex 500, SkyHoehe, 500, color, color, 1, 0, vxHorizont(StartVertex + 4)
    DX7.CreateD3DLVertex 500, BodenUrsprung, 500, color, color, 1, 1, vxHorizont(StartVertex + 5)
    
    DX7.CreateD3DLVertex 500, SkyHoehe, 500, color, color, 0, 0, vxHorizont(StartVertex + 6)
    DX7.CreateD3DLVertex 500, BodenUrsprung, -500, color, color, 1, 1, vxHorizont(StartVertex + 7)
    DX7.CreateD3DLVertex 500, BodenUrsprung, 500, color, color, 0, 1, vxHorizont(StartVertex + 8)
    DX7.CreateD3DLVertex 500, SkyHoehe, 500, color, color, 0, 0, vxHorizont(StartVertex + 9)
    DX7.CreateD3DLVertex 500, SkyHoehe, -500, color, color, 1, 0, vxHorizont(StartVertex + 10)
    DX7.CreateD3DLVertex 500, BodenUrsprung, -500, color, color, 1, 1, vxHorizont(StartVertex + 11)
    
    DX7.CreateD3DLVertex 500, SkyHoehe, -500, color, color, 0, 0, vxHorizont(StartVertex + 12)
    DX7.CreateD3DLVertex -500, BodenUrsprung, -500, color, color, 1, 1, vxHorizont(StartVertex + 13)
    DX7.CreateD3DLVertex 500, BodenUrsprung, -500, color, color, 0, 1, vxHorizont(StartVertex + 14)
    DX7.CreateD3DLVertex 500, SkyHoehe, -500, color, color, 0, 0, vxHorizont(StartVertex + 15)
    DX7.CreateD3DLVertex -500, SkyHoehe, -500, color, color, 1, 0, vxHorizont(StartVertex + 16)
    DX7.CreateD3DLVertex -500, BodenUrsprung, -500, color, color, 1, 1, vxHorizont(StartVertex + 17)
    
    DX7.CreateD3DLVertex -500, SkyHoehe, -500, color, color, 0, 0, vxHorizont(StartVertex + 18)
    DX7.CreateD3DLVertex -500, BodenUrsprung, 500, color, color, 1, 1, vxHorizont(StartVertex + 19)
    DX7.CreateD3DLVertex -500, BodenUrsprung, -500, color, color, 0, 1, vxHorizont(StartVertex + 20)
    DX7.CreateD3DLVertex -500, SkyHoehe, -500, color, color, 0, 0, vxHorizont(StartVertex + 21)
    DX7.CreateD3DLVertex -500, SkyHoehe, 500, color, color, 1, 0, vxHorizont(StartVertex + 22)
    DX7.CreateD3DLVertex -500, BodenUrsprung, 500, color, color, 1, 1, vxHorizont(StartVertex + 23)
    Exit Sub
ErrOut:
    Debug.Print Err.Number & " - " & Err.Description
End Sub
